<?php

// Register widgetized areas
function child_theme_widgets_init() {

  register_sidebar( array (
  'name' => 'Header Left Widget Area',
  'id' => 'header_left_widget_area', 
  'description' => __( 'Appears in the pre header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Header Right Widget Area',
  'id' => 'header_right_widget_area', 
  'description' => __( 'Appears in the pre header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Header Top Widget Area',
  'id' => 'header_top_widget_area', 
  'description' => __( 'Appears in the header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Mobile Icon Widget Area',
  'id' => 'mobile_icon_widget_area', 
  'description' => __( 'Appears in the pre header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'CTA Buttons Widget Area',
  'id' => 'cta_buttons_widget_area', 
  'description' => __( 'Appears in the navigation of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Logo Widget Area',
  'id' => 'logo_widget_area', 
  'description' => __( 'Appears in the sub-footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );

  register_sidebar( array (
  'name' => 'Header Right Google Ads Widget Area',
  'id' => 'header_right_ad_widget_area', 
  'description' => __( 'Appears in the header of Google Ads landing pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Footer Top Widget Area',
  'id' => 'footer_top_widget_area', 
  'description' => __( 'Appears in the footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Footer Menu Widget Area',
  'id' => 'footer_menu_widget_area', 
  'description' => __( 'Appears in the footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Sub Footer Left Center Widget Area',
  'id' => 'sub_footer_left_widget_area', 
  'description' => __( 'Appears in the footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Footer Mid Widget Area',
  'id' => 'footer_mid_widget_area', 
  'description' => __( 'Appears in the mid-footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Sub Footer Right Center Widget Area',
  'id' => 'sub_footer_right_widget_area', 
  'description' => __( 'Appears in the footer of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'Copyright Widget Area',
  'id' => 'copyright_widget_area', 
  'description' => __( 'Appears in the pre header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
	
  register_sidebar( array (
  'name' => 'EB Tag Widget Area',
  'id' => 'ebtag_widget_area', 
  'description' => __( 'Appears in the pre header of all pages', 'slg-2024' ),
  'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
  'after_widget' => "</li>"
  ) );
  
} // end theme_widgets_init


add_action( 'widgets_init', 'child_theme_widgets_init' );

function remove_unwanted_widgets(){
	

	// Unregister some of the parent theme sidebars
	unregister_sidebar( 'page_right_widget_area' );
	unregister_sidebar( 'blog_right_widget_area' );
	unregister_sidebar( 'page_bottom_widget_area' );
	unregister_sidebar( 'page_bottom_left_widget_area' );
	unregister_sidebar( 'page_bottom_right_widget_area' );
	unregister_sidebar( 'header_widget_area' );
	unregister_sidebar( 'footer_widget_area' );
}
add_action( 'widgets_init', 'remove_unwanted_widgets', 11 );

if ( ! isset( $content_width ) ) {
    $content_width = 1145;
}

// register the menus
add_action( 'init', 'register_home_menu' );
function register_home_menu() {
  register_nav_menus(
    array(
      'topnavMobile-menu' => __( 'Topnav Mobile Menu' ),
	  'headerSocial-menu' => __( 'Header Social Menu' ),
      'legal-menu' => __( 'Legal/Compliance Menu' ),
      'cta-menu' => __( 'CTA Menu' )
    )
  );
}

function eb_enqueue_my_styles_scripts() {
    wp_enqueue_style( 'bootstrap', '//cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css' );
    wp_enqueue_style( 'eb-blank-canvas', get_template_directory_uri() . '/css/wp.css' );
    wp_enqueue_style( 'slg-2024', get_stylesheet_uri() );
	
    // jQuery is stated as a dependancy of bootstrap-js - it will be loaded by WordPress before the BS scripts 
    wp_enqueue_script( 'bootstrap-js', '//cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js', array('jquery'), true ); // all the bootstrap javascript goodness

}
add_action('wp_enqueue_scripts', 'eb_enqueue_my_styles_scripts');


// Declare WooCommerce support

remove_action( 'woocommerce_before_main_content', 'woocommerce_output_content_wrapper', 10);
remove_action( 'woocommerce_after_main_content', 'woocommerce_output_content_wrapper_end', 10);

add_action('woocommerce_before_main_content', 'my_theme_wrapper_start', 10);
add_action('woocommerce_after_main_content', 'my_theme_wrapper_end', 10);

function my_theme_wrapper_start() {
  echo '<div id="container"><div id="content" role="main" class="container woocommerce">';
}

function my_theme_wrapper_end() {
  echo '</div></div>';
}

add_action( 'after_setup_theme', 'woocommerce_support' );
function woocommerce_support() {
    add_theme_support( 'woocommerce' );
}

// Hide placeholder images in WooCommerce
function woocommerce_template_loop_product_thumbnail() {
    global $post;
    if ( has_post_thumbnail() )
          echo get_the_post_thumbnail( $post->ID, 'shop_catalog' );
}
function woocommerce_show_product_images() {
    global $post;
    if ( has_post_thumbnail() )
           wc_get_template( 'single-product/product-image.php' );
}

add_action( 'after_setup_theme', 'my_theme_setup' );
 
function my_theme_setup() {
    add_theme_support( 'wc-product-gallery-zoom' );
    add_theme_support( 'wc-product-gallery-lightbox' );
    add_theme_support( 'wc-product-gallery-slider' );
}

// tn custom excerpt length
function my_excerpt_length($length){
return 20;
}
add_filter('excerpt_length', 'my_excerpt_length');

/**
* Filter the custom inner shortcodes array to add your own shortcode 'myshortcode'
* @param $shortcodes (array)
* @return $shortcodes
*/
add_filter('wpv_custom_inner_shortcodes', 'prefix_add_my_shortcodes');
 
function prefix_add_my_shortcodes($shortcodes) {
    $shortcodes[] = 'myshortcode';
    return $shortcodes;
}

add_filter( 'tribe_tickets_ticket_login_url', 'eb_tribe_tickets_ticket_login_url' );
function eb_tribe_tickets_ticket_login_url ( $login_url ) {
   // return the permalink to post id = 2
   $login_url = get_site_url() . '/my-account';
   return $login_url;
}

// Continue shopping redirect
add_filter( 'woocommerce_return_to_shop_redirect', 'st_woocommerce_shop_url' );
/**
 * Redirect WooCommerce Shop URL
 */

function st_woocommerce_shop_url(){

return site_url() . '/merchandise/';

}

/*Allow Span tags in editor*/
function myextensionTinyMCE($init) {
    // Command separated string of extended elements
    $ext = 'span[id|name|class|style]';

    // Add to extended_valid_elements if it alreay exists
    if ( isset( $init['extended_valid_elements'] ) ) {
        $init['extended_valid_elements'] .= ',' . $ext;
    } else {
        $init['extended_valid_elements'] = $ext;
    }

    // Super important: return $init!
    return $init;
}

add_filter('tiny_mce_before_init', 'myextensionTinyMCE' );

remove_action( 'template_redirect', 'wp_old_slug_redirect', 20 );
