<!DOCTYPE html>
<html xmlns="https://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
<head profile="https://gmpg.org/xfn/11">
<?php include_once("tag-manager-head.php") ?>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="format-detection" content="telephone=no">
<title>
<?php wp_title( '|', true, 'right' ); ?>
</title>
<meta http-equiv="content-type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>"/>
<?php if ( is_singular() ) wp_enqueue_script( 'comment-reply' ); ?>
<link rel="alternate" type="application/rss+xml" href="<?php bloginfo('rss2_url'); ?>" title="<?php printf( __( '%s latest posts', 'slg-2024' ), wp_specialchars( get_bloginfo('name'), 1 ) ); ?>"/>
<link rel="alternate" type="application/rss+xml" href="<?php bloginfo('comments_rss2_url') ?>" title="<?php printf( __( '%s latest comments', 'slg-2024' ), wp_specialchars( get_bloginfo('name'), 1 ) ); ?>"/>
<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>"/>
<link rel="shortcut icon" href="<?php echo get_stylesheet_directory_uri(); ?>/images/bcr-favicon.ico"/>
<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>
<?php include_once("tag-manager-body.php") ?>
<a href="#content" class="offScreen">Skip to Main Content</a>
<?php get_sidebar('headerTop'); ?>
<header class="header <?php echo $args['class']; ?> container-fluid <?php if ( is_front_page() ) : ?>home<?php endif; ?>">
  <div class="topnavMobile">
    <div class="row d-block d-md-none">
      <?php get_sidebar('mobileIcon'); ?>
      <?php wp_nav_menu( array( 'theme_location' => 'topnavMobile-menu' ) ); ?>
    </div>
  </div>
  <div class="main-nav container-xl">
    <div class="row branding">	
      <div class="logo col-12 col-md-3">
        <?php get_sidebar('logo'); ?>
      </div>
      <div class="d-none d-md-block col-md-4">
        <?php get_sidebar('headerLeft'); ?>
      </div>
    <div class="col-12 col-md-5 cta"> <?php get_sidebar('headerRight'); ?> </div>
    </div>
    <div class="row">
      <div class="topnav d-md-block col-12 align-self-center">
        <div class="d-none d-md-block">
          <?php wp_nav_menu( array( 'theme_location' => 'topnav-menu' ) ); ?>
        </div>
      </div>
    </div>
  </div>
</header>
