<?php get_header(); ?>
<!-- search.php -->
<div id="content">
  <div class="container">
    <h1 class="page-title d-block">
      <?php _e( 'Search Results for: ', 'slg-2024' ); ?>
      <span>
      <?php the_search_query(); ?>
      </span> </h1>
    <?php if ( have_posts() ) : ?>
    <?php global $wp_query; $total_pages = $wp_query->max_num_pages; if ( $total_pages > 1 ) { ?>
    <div id="nav-above" class="navigation">
      <div class="nav-previous">
        <?php previous_posts_link(__( '<span class="meta-nav"><i class="fas fa-star"></i></span> Previous Results', 'slg-2024' )) ?>
      </div>
      <div class="nav-next">
        <?php next_posts_link(__( 'More Results <span class="meta-nav"><i class="fas fa-star"></i></span>', 'slg-2024' )) ?>
      </div>
    </div>
    <!-- #nav-above -->
    <?php } ?>
    <?php while ( have_posts() ) : the_post() ?>
    <div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
      <h2 class="entry-title"><a href="<?php the_permalink(); ?>" title="<?php printf( __('Permalink to %s', 'slg-2024'), the_title_attribute('echo=0') ); ?>" rel="bookmark">
        <?php the_title(); ?>
        </a></h2>
      <?php if ( $post->post_type == 'post' ) { ?>
      <div class="entry-meta"> <span class="meta-prep meta-prep-author">
        <?php _e('By ', 'slg-2024'); ?>
        </span> <span class="author vcard"><a class="url fn n" href="<?php echo get_author_link( false, $authordata->ID, $authordata->user_nicename ); ?>" title="<?php printf( __( 'View all posts by %s', 'slg-2024' ), $authordata->display_name ); ?>">
        <?php the_author(); ?>
        </a></span> <span class="meta-sep"> | </span> <span class="meta-prep meta-prep-entry-date">
        <?php _e('Published ', 'slg-2024'); ?>
        </span> <span class="entry-date"><abbr class="published" title="<?php the_time('Y-m-d\TH:i:sO') ?>">
        <?php the_time( get_option( 'date_format' ) ); ?>
        </abbr></span>
        <?php edit_post_link( __( 'Edit', 'slg-2024' ), "<span class=\"meta-sep\">|</span>\n\t\t\t\t\t\t<span class=\"edit-link\">", "</span>\n\t\t\t\t\t" ) ?>
      </div>
      <!-- .entry-meta -->
      <?php } ?>
      <div class="entry-summary">
        <?php the_excerpt( __( 'Continue reading <span class="meta-nav">&raquo;</span>', 'slg-2024' )  ); ?>
        <?php wp_link_pages('before=<div class="page-link">' . __( 'Pages:', 'slg-2024' ) . '&after=</div>') ?>
      </div>
      <!-- .entry-summary -->
      <?php if ( $post->post_type == 'post' ) { ?>
      <div class="entry-utility"> <span class="cat-links"><span class="entry-utility-prep entry-utility-prep-cat-links">
        <?php _e( 'Posted in ', 'slg-2024' ); ?>
        </span><?php echo get_the_category_list(', '); ?></span> <span class="meta-sep"> | </span>
        <?php the_tags( '<span class="tag-links"><span class="entry-utility-prep entry-utility-prep-tag-links">' . __('Tagged ', 'slg-2024' ) . '</span>', ", ", "</span>\n\t\t\t\t\t\t<span class=\"meta-sep\">|</span>\n" ) ?>
        <span class="comments-link">
        <?php comments_popup_link( __( 'Leave a comment', 'slg-2024' ), __( '1 Comment', 'slg-2024' ), __( '% Comments', 'slg-2024' ) ) ?>
        </span>
        <?php edit_post_link( __( 'Edit', 'slg-2024' ), "<span class=\"meta-sep\">|</span>\n\t\t\t\t\t\t<span class=\"edit-link\">", "</span>\n\t\t\t\t\t\n" ) ?>
      </div>
      <!-- #entry-utility -->
      <?php } ?>
    </div>
    <!-- #post-<?php the_ID(); ?> -->
    <?php endwhile; ?>
    <?php global $wp_query; $total_pages = $wp_query->max_num_pages; if ( $total_pages > 1 ) { ?>
    <div id="nav-below" class="navigation">
      <div class="nav-previous">
        <?php previous_posts_link(__( '<span class="meta-nav"><i class="fas fa-star"></i></span> Previous Results', 'slg-2024' )) ?>
      </div>
      <div class="nav-next">
        <?php next_posts_link(__( 'More Results <span class="meta-nav"><i class="fas fa-star"></i></span>', 'slg-2024' )) ?>
      </div>
    </div>
    <!-- #nav-below -->
    <?php } ?>
    <?php else : ?>
    <div id="post-0" class="post no-results not-found">
      <h2 class="entry-title">
        <?php _e( 'Nothing Found', 'slg-2024' ) ?>
      </h2>
      <div class="entry-content">
		  <p>Please try again with some different keywords.</p>
      </div>
	 <?php get_search_form(); ?>

      <!-- .entry-content --> 
    </div>
    <?php endif; ?>
    <!-- #content --> 
  </div>
  <!-- #container --> 
</div>
<?php get_footer(); ?>
